VERSION 5.00
Begin VB.Form frmServiceInfo 
   Caption         =   "Service Information"
   ClientHeight    =   3330
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5715
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3330
   ScaleWidth      =   5715
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   375
      Left            =   4410
      TabIndex        =   5
      Top             =   2880
      Width           =   1230
   End
   Begin VB.ListBox lstServiceInfo 
      Height          =   2010
      Left            =   90
      TabIndex        =   2
      Top             =   765
      Width           =   5550
   End
   Begin VB.CommandButton cmdService 
      Caption         =   "&Display Info"
      Height          =   375
      Left            =   4590
      TabIndex        =   1
      Top             =   45
      Width           =   1005
   End
   Begin VB.TextBox txtServiceName 
      Height          =   285
      Left            =   1305
      TabIndex        =   0
      Top             =   90
      Width           =   3165
   End
   Begin VB.Label Label2 
      Caption         =   "Service Information"
      Height          =   195
      Left            =   90
      TabIndex        =   4
      Top             =   540
      Width           =   1725
   End
   Begin VB.Label Label1 
      Caption         =   "&Service Name:"
      Height          =   195
      Left            =   90
      TabIndex        =   3
      Top             =   135
      Width           =   1140
   End
End
Attribute VB_Name = "frmServiceInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   NT Service: This sample code demonstrates how a
'       Visual Basic program can interact with the NT
'       Service Manager
'
'   Demonstration Created by Microsoft and made more readable
'   by Joseph Guadagno; jguadagno@beyondvb.com
'   for Beyond The Basics Of Visual Basic
'   http://www.beyondvb.com
'
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Option Explicit

Private Declare Function CloseServiceHandle Lib "advapi32.dll" _
      (ByVal hSCObject As Long) As Long
Private Declare Function QueryServiceStatus Lib "advapi32.dll" _
   (ByVal hService As Long, _
   lpServiceStatus As SERVICE_STATUS) As Long
Private Declare Function OpenService Lib "advapi32.dll" _
   Alias "OpenServiceA" _
   (ByVal hSCManager As Long, _
   ByVal lpServiceName As String, _
   ByVal dwDesiredAccess As Long) As Long
Private Declare Function OpenSCManager Lib "advapi32.dll" _
   Alias "OpenSCManagerA" _
   (ByVal lpMachineName As String, _
   ByVal lpDatabaseName As String, _
   ByVal dwDesiredAccess As Long) As Long
Private Declare Function QueryServiceConfig Lib "advapi32.dll" _
   Alias "QueryServiceConfigA" _
   (ByVal hService As Long, _
   lpServiceConfig As Byte, _
   ByVal cbBufSize As Long, _
   pcbBytesNeeded As Long) As Long
Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" _
   (hpvDest As Any, _
   hpvSource As Any, _
   ByVal cbCopy As Long)
Private Declare Function lstrcpy Lib "KERNEL32" Alias "lstrcpyA" _
   (ByVal lpString1 As String, _
   ByVal lpString2 As Long) As Long
      
Private Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type
   
Private Type QUERY_SERVICE_CONFIG
    dwServiceType As Long
    dwStartType As Long
    dwErrorControl As Long
    lpBinaryPathName As Long 'String
    lpLoadOrderGroup As Long ' String
    dwTagId As Long
    lpDependencies As Long 'String
    lpServiceStartName As Long 'String
    lpDisplayName As Long  'String
End Type
   
Private Const SERVICE_STOPPED = &H1
Private Const SERVICE_START_PENDING = &H2
Private Const SERVICE_STOP_PENDING = &H3
Private Const SERVICE_RUNNING = &H4
Private Const SERVICE_CONTINUE_PENDING = &H5
Private Const SERVICE_PAUSE_PENDING = &H6
Private Const SERVICE_PAUSED = &H7
Private Const SERVICE_ACCEPT_STOP = &H1
Private Const SERVICE_ACCEPT_PAUSE_CONTINUE = &H2
Private Const SERVICE_ACCEPT_SHUTDOWN = &H4
Private Const SC_MANAGER_CONNECT = &H1
Private Const SERVICE_INTERROGATE = &H80
Private Const GENERIC_READ = &H80000000
Private Const ERROR_INSUFFICIENT_BUFFER = 122

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   DisplayServiceInformation: Querys the NT Service
'       manager for information about the NT Service
'
'   Parameters: objControl; the control that will
'       display the information about the service
'   Returns: Zero upon success, other a long value
'       indicating the error

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Function DisplayServiceInformation(objControl As Control, ServiceName As String) As Long

    Dim hSCM            As Long
    Dim hSVC            As Long
    Dim pSTATUS         As SERVICE_STATUS
    Dim udtConfig       As QUERY_SERVICE_CONFIG
    Dim lngReturn       As Long
    Dim lngBytesNeeded  As Long
    Dim strTemp         As String
    Dim pFileName       As Long
      
    ' Initialize the Function to 0, everything went OK
    DisplayServiceInformation = 0
    
    objControl.Clear
      
    ' Open The Service Control Manager      '
    hSCM = OpenSCManager(vbNullString, vbNullString, SC_MANAGER_CONNECT)
    If hSCM = 0 Then
        DisplayServiceInformation = Err.LastDllError
        GoTo CloseHandles
    End If
    
    ' Open the specific Service to obtain a handle      '
    hSVC = OpenService(hSCM, Trim(ServiceName), GENERIC_READ)
    
    If hSVC = 0 Then
        DisplayServiceInformation = Err.LastDllError
        GoTo CloseHandles
    End If
        
    ' Fill the Service Status Structure      '
    lngReturn = QueryServiceStatus(hSVC, pSTATUS)
    If lngReturn = 0 Then
       DisplayServiceInformation = Err.LastDllError
       GoTo CloseHandles
    End If
    
    ' Report the Current State      '
    Select Case pSTATUS.dwCurrentState
        Case SERVICE_STOPPED
            strTemp = "The Service is Stopped"
        Case SERVICE_START_PENDING
            strTemp = "The Service Being Started"
        Case SERVICE_STOP_PENDING
            strTemp = "The Service is in the process of being stopped"
        Case SERVICE_RUNNING
            strTemp = "The Service is Running"
        Case SERVICE_CONTINUE_PENDING
            strTemp = "The Service is in the process of being Continued"
        Case SERVICE_PAUSE_PENDING
            strTemp = "The Service is in the process of being Paused"
        Case SERVICE_PAUSED
            strTemp = "The Service is Paused"
        Case SERVICE_ACCEPT_STOP
            strTemp = "The Service is Stopped"
        Case SERVICE_ACCEPT_PAUSE_CONTINUE
            strTemp = "The Service is "
        Case SERVICE_ACCEPT_SHUTDOWN
            strTemp = "The Service is being Shutdown"
    End Select
      
    objControl.AddItem "Service Status : " & strTemp
    
    ' Call QueryServiceConfig with 1 byte buffer to generate an error
    ' that returns the size of a buffer we need.      '
    ReDim abConfig(0) As Byte
    lngReturn = QueryServiceConfig(hSVC, abConfig(0), 0&, lngBytesNeeded)
    
    If lngReturn = 0 And Err.LastDllError <> ERROR_INSUFFICIENT_BUFFER Then
         DisplayServiceInformation = Err.LastDllError
         GoTo CloseHandles
    End If
      
    ' Redim our byte array to the size necessary and call
    ' QueryServiceConfig again      '
    ReDim abConfig(lngBytesNeeded) As Byte
    lngReturn = QueryServiceConfig(hSVC, abConfig(0), lngBytesNeeded, lngBytesNeeded)
    
    If lngReturn = 0 Then
        DisplayServiceInformation = Err.LastDllError
        GoTo CloseHandles
    End If
    
    ' Fill our Service Config User Defined Type.      '
    CopyMemory udtConfig, abConfig(0), Len(udtConfig)
    objControl.AddItem "Service Type: " & udtConfig.dwServiceType
    objControl.AddItem "Service Start Type: " & udtConfig.dwStartType
    objControl.AddItem "Service Error Control: " & udtConfig.dwErrorControl
    strTemp = Space(255)
    ' Now use the pointer obtained to copy the path into the temporary
    ' String Variable      '
    lngReturn = lstrcpy(strTemp, udtConfig.lpBinaryPathName)
    objControl.AddItem "Service Binary Path: " & strTemp
    lngReturn = lstrcpy(strTemp, udtConfig.lpDependencies)
    objControl.AddItem "Service Dependencies: " & strTemp
    lngReturn = lstrcpy(strTemp, udtConfig.lpDisplayName)
    objControl.AddItem "Service DisplayName: " & strTemp
    lngReturn = lstrcpy(strTemp, udtConfig.lpLoadOrderGroup)
    objControl.AddItem "Service LoadOrderGroup: " & strTemp
    lngReturn = lstrcpy(strTemp, udtConfig.lpServiceStartName)
    objControl.AddItem "Service Start Name: " & strTemp

CloseHandles:
   ' Close the Handle to the Service   '
   CloseServiceHandle (hSVC)
   ' Close the Handle to the Service Control Manager   '
   CloseServiceHandle (hSCM)

End Function

Private Sub cmdClose_Click()
    Unload Me
End Sub


Private Sub cmdService_Click()

    Dim lngResult   As Long
    
    lngResult = DisplayServiceInformation(lstServiceInfo, txtServiceName.Text)
    
    If lngResult <> 0 Then
       MsgBox "There was an error getting the information about the service." _
         & vbCrLf & "The error number was " & Trim$(Str$(lngResult)), vbCritical
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set frmServiceInfo = Nothing
End Sub



